

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//             OC_Mapper:  Outputs opacity maps for 8bit bmp files            //
//             Drap n' Drop Utility                                           //
//             Author:  Rebel  02/17/2010                                     //
//             Language: C/C++                                                //
//             IDE: DEV_C++  VER.4.92                                         //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////



#include <string>
#include <iostream>
#include <fstream>
#include <windows.h>  /* Include for MessageBoxes & GetModule */
#include "palette.c"  /* The palette used (rawData) */


 int main(int argc, char * argv[])
{
  ifstream datFile;
  ofstream opcFile;
  int wildcard;
  
  string OrigFile, OpcFile, FileTemp, SmlFile, CckFile;
  
  char Path[MAX_PATH];
  GetModuleFileName(NULL, Path, MAX_PATH);


////////////////////////////////////////////////////////////////////////////////
////// Do our little string dance and build desired pathway + file_names /////// 
   
         if(argv[1]>0)
          {
           SmlFile=argv[1];
           FileTemp=Path;
           OrigFile=argv[1];
           
           int cutoff = FileTemp.find_last_of("\\");
           FileTemp.erase(cutoff+1);
           CckFile=FileTemp;
           CckFile+="ocm_variable.ini";
           
////////////////////////////////////////////////////////////////////////////////  
////////  Pause - Check for Variable - If file missing, recreate it  /////////// 


       ifstream wildnum(CckFile.c_str(), ios::in);
     
          if(wildnum.good())
           {
           wildnum>>wildcard;
           wildnum.close();
           }
       
            else{
             ofstream wm_create(CckFile.c_str(), ios::out);
             wm_create<<"1 ::End_Name Variable (Wording is descriptive, unused)"
             <<endl;
             wm_create.close();
             
             wildcard=1;
             }

                
////////////////////////////////////////////////////////////////////////////////
/// Complete our string appending and pathways - check for actual file_drop ////
           
    
           int keepath = SmlFile.rfind("\\");
           SmlFile.erase(0,keepath+1);
           int killbmp = SmlFile.rfind(".");
           SmlFile.erase(killbmp-wildcard);

                    
           OpcFile=FileTemp;
           OpcFile+=SmlFile;
           OpcFile+="o8.bmp";
          }
 
              else {
                /* No file drop. ... destroy this window */
              MessageBox(NULL, "Error. Please drop file onto application"
              " window (drag n' drop)",
              "OPACITY_MAPPER",MB_OK);
              return 0;
               }

         
////////////////////////////////////////////////////////////////////////////////               
//Let's get our file size and check to see if this is actually an 8bit bitmap //

     datFile.open(OrigFile.c_str(), ios::in | ios::binary);
     
        datFile.seekg( 0, ios::end );
        int bmpsize = datFile.tellg();
        datFile.seekg( 0, ios::beg );
        
        bmpsize = bmpsize - 1078;
 
        char bmptype;
        int bmptype_int;
       
        datFile.seekg(0x1C,ios::beg);
        datFile.read(&bmptype, 1);
       
        bmptype_int=bmptype;
       
          if(bmptype_int==8)
          {
           datFile.seekg(0, ios::beg);
           opcFile.open(OpcFile.c_str(), ios::out | ios::binary);
          }
     
              else{
              MessageBox(NULL,"File is not an 8bit bmp! Click OK to close. ..",
              "OPACITY_MAPPER",MB_OK);
              datFile.close();
        
              return 0; /* Not an 8bit .bmp file_drop, destroy window */
               }
               
 ///////////////////////////////////////////////////////////////////////////////
 /////// Read n' Copy Org_Header info and write that out + our palette /////////   
 
        int count = 0;
        
		char buffer[54];
		char tempchar[2];
        char tempblue[2]={0x00};
        char tempblack[2]={0xFF};
        char tempwhite[2]={0x00};
 
        int result;
		
		        datFile.seekg(0, ios::beg);
		        datFile.read(&buffer, 54);
    			
		        opcFile.write((char *)(&buffer), sizeof(buffer)); 
		        opcFile.write((char *)(&rawData), sizeof(rawData)); 
    			
    			datFile.seekg(1078, ios::beg);
    			
////////////////////////////////////////////////////////////////////////////////
///// Read thru our 8bit file; write out our replacement bytes accordingly /////
          	
            while (count<bmpsize)
                {
                ++count;
            
                  datFile.read(&tempchar, 1);
                  
                result = strcmp(tempchar,tempblue);
                
                    if( result>0)
                     {
      		        opcFile.write((char *)(&tempblack), 1); 
                     }
                 
                else
                {                                   
  		         opcFile.write((char *)(&tempwhite), 1);             
                } 	     
              }
////////////////////////////////////////////////////////////////////////////////
/////////// Finished.  Let's be tidy and close out our open files. /////////////
              
               datFile.close();
               opcFile.close(); 
               
               return 0;
              }

